//+------------------------------------------------------------------+
//|                                              qpu_EMA-Rainbow.mq5 |
//|                                       Copyright 2012, MetaDriver |
//|                                            MetaDriver@rambler.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaDriver"
#property link      "MetaDriver@rambler.ru"
#property version   "1.00"
#define  CountLine  512
#define  clBufLength  1024
#property indicator_chart_window
#property indicator_buffers CountLine
#property indicator_plots   CountLine
//--- plot Ema_01
//#property indicator_label1  "Ema_01"
//#property indicator_type1   DRAW_LINE
//#property indicator_color1  clrRed,C'0,0,0',C'0,0,0',C'0,0,0',C'0,0,0',C'0,0,0',C'0,0,0',C'0,0,0'
//#property indicator_style1  STYLE_SOLID
//#property indicator_width1  1
//--- input parameters
input int      HiPeriod=3;
// input int      CountLine=8;
input int      PeriodStep=2;
input color    FastColor=clrPaleVioletRed;
input color    MiddleColor=clrDarkTurquoise;
input color    SlowColor=clrMaroon;
input int      ColorApproximationMethod=0;
//--- 
struct SBuffer
  {
   double            B[];
  };
//--- indicator buffers
SBuffer         EmaBuffer[CountLine];
//--- Calc buffers  and other vars
float            gpu_Buffer[][CountLine];

color Colors[CountLine];
bool First=true;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   InitColors();
   for(int i=0;i<CountLine;i++)
     {
      InitBuffers(i);
     }
//---
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void InitColors()
  {
   int Half = CountLine/2;
   for(int i=0;i<Half;i++)
     {
      if(i%4==3)
        {
         Colors[i]=MixColor(SlowColor>>1,MiddleColor>>1,i*1.0/Half);
        }
      else
        {
         Colors[i]=MixColor(SlowColor,MiddleColor,i*1.0/Half);
        }
     }
   for(int i=Half;i<CountLine;i++)
     {
      if(i%4==3)
        {
         Colors[i]=MixColor(MiddleColor>>1,FastColor>>1,(i-Half)*1.0/Half);
        }
      else
        {
         Colors[i]=MixColor(MiddleColor,FastColor,(i-Half)*1.0/Half);
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
color MixColor(color A,color B,double mix)
  {
   int r = (int)MathRound((B & 0xFF) * mix + (A & 0xFF) * (1 - mix));
   int g = (int)MathRound((B>>8 & 0xFF) * mix + (A>>8 & 0xFF) * (1 - mix));
   int b = (int)MathRound((B>>16 & 0xFF) * mix + (A>>16 & 0xFF) * (1 - mix));
   return color(r|g<<8|b<<16);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void InitBuffers(int index)
  {
   SetIndexBuffer(index,EmaBuffer[index].B,INDICATOR_DATA);
   PlotIndexSetInteger(index,PLOT_DRAW_TYPE,DRAW_LINE);
//   PlotIndexSetInteger(index,PLOT_DRAW_TYPE,DRAW_LINE);
   PlotIndexSetInteger(index,PLOT_LINE_COLOR,Colors[index]);
   if(index%8==7) PlotIndexSetInteger(index,PLOT_LINE_WIDTH,2);
   ArraySetAsSeries(EmaBuffer[index].B,true);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//---
   ArraySetAsSeries(price,true);
   if(First)
     {
      for(int i=0;i<CountLine;i++)
        {
         //         ArraySetAsSeries(EmaBuffer[i].B, true);
         //         EmaBuffer[i].B[rates_total-1] = price[rates_total-1];
         EmaBuffer[i].B[rates_total-1]=price[rates_total-1];
         First=false;
        }
     }
   int limit=rates_total-prev_calculated;
   if(limit==1) limit++;
   for(int i=0;i<CountLine;i++)
     {
      double p=2./(HiPeriod+PeriodStep*(CountLine-i)+1);
      for(int j=limit-2;j>=0;j--)
        {
         //         EmaBuffer[i].B[j] = price[j]+(0.0001*i-0.0032)*5;
         EmaBuffer[i].B[j]=price[j]*p+EmaBuffer[i].B[j+1]*(1.-p);
        }
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
